#import "AppController.h"
#import "Port.h"
#import "InstalledPort.h"
#import "OutdatedPort.h"

@implementation AppController

- (void) awakeFromNib {
    array = [[NSMutableArray alloc] init];
    
    NSThread *thread = [[NSThread alloc] initWithTarget:self selector:@selector(installed:) object:nil];
    [thread start];
    //[self installed:nil];
}

- (void) method {
    [self installed:nil];
}

- (int) numberOfRowsInTableView:(NSTableView *)tv
{
    return [array count];
}

- (id) tableView:(NSTableView *)tv
        objectValueForTableColumn:(NSTableColumn *)tableColumn
        row:(int)row
{
    if ([segmentedControl selectedSegment] == 0) {
        InstalledPort *x = [array objectAtIndex:row];
        
        if ([[tv tableColumns] indexOfObject:tableColumn] == 0)
            return [x name];
        else if ([[tv tableColumns] indexOfObject:tableColumn] == 1)
            return [x version];
        else if ([[tv tableColumns] indexOfObject:tableColumn] == 2)
            if ([x isActive])
                return @"yes";
    }
    else if ([segmentedControl selectedSegment] == 1) {
        OutdatedPort *x = [array objectAtIndex:row];

        if ([[tv tableColumns] indexOfObject:tableColumn] == 0)
            return [x name];
        else if ([[tv tableColumns] indexOfObject:tableColumn] == 1)
            return [x oldVersion];
        else if ([[tv tableColumns] indexOfObject:tableColumn] == 2)
            return [x newVersion];
    }
    
    return @"";
}

- (void)tableViewSelectionDidChange:(NSNotification *)notification {
    NSInteger index = [table selectedRow];
    Port *port = [array objectAtIndex:index];
    //NSString *description = [port description];
    NSArray *ary = [NSArray arrayWithObjects:@"info", [port name], nil];
    
    [textField setStringValue:[self run:ary]];
}

- (void)blurg:(id)sender {
    NSLog([NSString stringWithFormat:@"testing out sudo"]);
    
    NSTask *task;
    task = [[NSTask alloc] init];
    [task setLaunchPath: @"/usr/bin/su"];
    
    NSArray *arguments;
    arguments = [NSArray arrayWithObjects: @"ls", nil];
    [task setArguments: arguments];
    
    NSPipe *pipe;
    pipe = [NSPipe pipe];
    [task setStandardOutput: pipe];
    
    NSFileHandle *file;
    file = [pipe fileHandleForReading];
    
    NSLog(@"launching...");
    [task launch];
    NSLog(@"launched");
    
    NSData *data;
    data = [file readDataToEndOfFile];
    
    [pipe dealloc];
    
    
    NSLog(@"data read");
    
    NSString *resultString;
    resultString = [[NSString alloc] initWithData: data encoding: NSUTF8StringEncoding];
    
    NSLog(@"string created");
    
    [task terminate];
    
    if (![task isRunning]) {
        int status = [task terminationStatus];
        NSLog([NSString stringWithFormat:@"%d", status]);
    }
    
    [textField setStringValue:resultString];
    
    NSLog(@"process is complete");    
}

- (void)changeView:(id)sender {
    NSLog(@"x");
    NSLog([NSString stringWithFormat:@"%@ clicked", [segmentedControl labelForSegment:[segmentedControl selectedSegment]]]);
    if ([segmentedControl selectedSegment] == 0)
        [self installed:sender];
    else if ([segmentedControl selectedSegment] == 1)
        [self outdated:sender];
    else if ([segmentedControl selectedSegment] == 2)
        [self unused:sender];
}

//- (void)list:(id)sender
//{
//    NSArray *installed = [self run:@"list"];
//    [label setStringValue:[NSString stringWithFormat:@"%d total ports available", [installed count]]];
//    [self printResults:installed];
//}

- (void)installed:(id)sender
{
    NSLog(@"installed button clicked");
    [label setStringValue:@"running \"ports installed\"..."];
    NSArray *installed = [self stringToArray:[self runSimple:@"installed"]];
    [label setStringValue:[NSString stringWithFormat:@"%d ports installed", [installed count]]];
    //[self printResults:installed];
    //NSLog(@"building new NSMutableArray");
    //NSMutableArray *ma = [NSMutableArray arrayWithCapacity:[installed count]];
    //for (NSString *str in installed) {
    //    NSLog(str);
    //    [ma addObject:[[InstalledPort alloc] initWithString:str]];
    //}
    [array removeAllObjects];
    
    NSInteger count = [installed count] - 1;
    
    for (int i = 0; i < count; i++) {
        NSString *str = [installed objectAtIndex:i];
        [array addObject:[[InstalledPort alloc] initWithString:str]];
    }
    
    //for (int n = 1; n <= [installed count]; n++) {
//        InstalledPort *ip = [[InstalledPort alloc] initWithString:[installed objectAtIndex:n]];
//        [installedPortsList addObject:ip];
//        //[table reloadData];
//    }
    
    NSLog(@"done");
    //installedPortsList = [NSArray arrayWithArray:ma];
    //[table setDelegate:installedPortsList];
[table reloadData];
    //[self printResults:installed];
    
    NSArray *columns = [table tableColumns];
    //[[columns objectAtIndex:0] setIdentifier:@"Version"];
    [[[columns objectAtIndex:0] headerCell] setStringValue:@"Name"];
    [[columns objectAtIndex:0] setHidden:NO];
    
    //[[columns objectAtIndex:1] setIdentifier:@"Version"];
    [[[columns objectAtIndex:1] headerCell] setStringValue:@"Version"];
    [[columns objectAtIndex:1] setHidden:NO];
    
    //[[columns objectAtIndex:2] setIdentifier:@"Active"];
    NSTableColumn *column = [columns objectAtIndex:2];
    NSTableHeaderCell *cell = [column headerCell];
    [cell setStringValue:@"Active"];
    [column setHidden:NO];
    
    [table reloadData];
    
    NSLog(@"xxx");
}

- (void)outdated:(id)sender
{
    NSLog(@"outdated button clicked");
    [label setStringValue:@"running \"ports installed\"..."];
    NSArray *outdated = [self stringToArray:[self runSimple:@"outdated"]];
    [label setStringValue:[NSString stringWithFormat:@"%d ports outdated", [outdated count]]];
    //[self printResults:outdated];
    
    [array removeAllObjects];
    
    NSInteger count = [outdated count] - 1;
    
    for (int i = 0; i < count; i++) {
        NSString *str = [outdated objectAtIndex:i];
        [array addObject:[[OutdatedPort alloc] initWithString:str]];
    }
    
    NSArray *columns = [table tableColumns];
    //[[columns objectAtIndex:0] setIdentifier:@"Old Version"];
    [[[columns objectAtIndex:0] headerCell] setStringValue:@"Name"];
    [[columns objectAtIndex:0] setHidden:NO];
    
    //[[columns objectAtIndex:1] setIdentifier:@"Old Version"];
    [[[columns objectAtIndex:1] headerCell] setStringValue:@"Current Version"];
    [[columns objectAtIndex:1] setHidden:NO];
    
    //[[columns objectAtIndex:2] setIdentifier:@"New Version"];
    [[[columns objectAtIndex:2] headerCell] setStringValue:@"Available Version"];
    [[columns objectAtIndex:2] setHidden:NO];
    
    [table reloadData];
}

- (void)unused:(id)sender
{
    NSLog(@"unused button clicked");
}

- (NSArray *) stringToArray:(NSString *)string {
    NSArray *resultArray = [string componentsSeparatedByString:@"\n"];
    
    NSRange range;
    
    range.location = 1;
    range.length = [resultArray count] - 1;
    
    return [resultArray subarrayWithRange:range];    
}

- (NSString *)runSimple:(NSString *)command {
    return [self run:[NSArray arrayWithObjects: command, nil]];
}

- (NSString *)run:(NSArray *)command, ...
{
    NSLog([NSString stringWithFormat:@"running \"port %@\"", command]);
    
    NSTask *task;
    task = [[NSTask alloc] init];
    [task setLaunchPath: @"/opt/local/bin/port"];
    
    NSArray *arguments;
    arguments = command;
    [task setArguments: arguments];
    
    NSPipe *pipe;
    pipe = [NSPipe pipe];
    [task setStandardOutput: pipe];
    
    NSFileHandle *file;
    file = [pipe fileHandleForReading];
    
    NSLog(@"launching...");
    [task launch];
    NSLog(@"launched");
    
    NSData *data;
    data = [file readDataToEndOfFile];
    
    [pipe dealloc];
    
    
    NSLog(@"data read");
    
    NSString *resultString;
    resultString = [[NSString alloc] initWithData: data encoding: NSUTF8StringEncoding];
    
    NSLog(@"string created");
    
    [task terminate];
    
    if (![task isRunning]) {
        int status = [task terminationStatus];
        NSLog([NSString stringWithFormat:@"%d", status]);
    }
    
    NSLog(@"process is complete");
    return resultString;
}

- (void)printResults:(NSArray *)resultArray {
    NSString *txt = @"";
    
    for (NSString *str in resultArray) {
        //NSArray *details = [str componentsSeparatedByString:@" "];
        
        //txt = [txt stringByAppendingString:[details objectAtIndex:0]];
        
        txt = [txt stringByAppendingString:str];
        
        //if ([details count] == 3 && [details objectAtIndex:2] == @"(active)") {
        //    txt = [txt stringByAppendingString:[details objectAtIndex:0]];
        //}
        //[details release];
    }
    
    //[textField setStringValue:[portItems objectAtIndex:0]];
    [textField setStringValue:txt];
}

@end
